      subroutine genps(nfsp)
c----------------------------------------------------------------------c
c Generates a multichannel Monte Carlo integration routine for 
c the process:
c
c                 1 + 2 -> 3 + 4 + ... + n
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c
c 11 May, 2021 
c modified 
c----------------------------------------------------------------------c

      use extpart
      use tchkins

      implicit none

      integer :: i,j,k,l,m,nfsp,ivp(mxks),icolon,nvks,np,
     &           ixpx,ivpx,iks,ixp(nfsp),iv,iyp(mxks,nfsp),ip,icrit,
     &           izp(nfsp),ipl,ipr,ifp(0:mxmap),ifpx,itp(nfsp),
     &           iup(nfsp),isp(nfsp)
      character(78) :: cline
      character(80) :: ckin0,ckin1,ckin2,ckin3,ind,cinds,
     &                 cnp,cnp1,cnp2,cnp3
      character(40), dimension(mxks) :: cvrt,cgam,ck,ci
      character(160) :: cls,ckin

      write(ind,'(i4)') nfsp
      ckin0='kin'//trim(adjustl(ind))//'_'

      open(unit=7,file='genps.dat',status='old',action='read')
      i=0
      do 
       read(7,'(i1,a78)',end=700) np,cline
       if (np /= 0) then
        i=i+1
        icolon=index(cline,':')
        ivp(i)=np
        cvrt(i)=cline(1:icolon-1)
        cgam(i)=cline(icolon+1:)
       end if
      end do
 700  nvks=i
      close(7)

      ixpx=0
      iv=0
      ckin=ckin0
      ci=''
      do i=1,nvks
       ivpx=0
       ixp=0
       cinds=''
       ifp=0
       do k=1,nfsp
        ifpx=index(cvrt(i),' '//trim(expc(nisp+k))//' ')
        if (ifpx > 0 .and. ifpx /= ifp(ivpx)) then
         ivpx=ivpx+1
         ifp(ivpx)=ifpx
         ixp(k)=nisp+k
         write(ind,'(i4)') ixp(k)
         cinds=trim(cinds)//trim(adjustl(ind))//','
         if (ivpx == ivp(i)) then
          iv=iv+1
          ci(iv)=trim(cinds)
          write(ind,'(i4)') ivp(i)
          ck(iv)=trim(adjustl(ind))
          ci(iv)=trim(ci(iv))//trim(adjustl(cgam(i)))//','
          iyp(iv,:)=ixp
          ivpx=0
          ixp=0
          cinds=''
         end if
        end if
       end do
      end do

c      do i=1,iv
c       write(*,*) i, iyp(i,:)
c       write(*,*) i, ci(i)
c       write(*,*) i, ck(i)
c      end do

      open(unit=19,file='schcalls.txt',status='replace',action='write')
      open(unit=20,file='schcalls2.txt',status='replace',action='write')

      iks=0
      ckin=''
      cnp=''
      do i=1,iv
c       do j=1,iv
       do j=i+1,iv
        icrit=0
        do ip=1,nfsp
         icrit=icrit+iyp(i,ip)*iyp(j,ip)
        end do
        if (icrit == 0) then
         izp=iyp(i,:)+iyp(j,:)
         ckin=trim(ckin)//trim(adjustl(ci(i)))//trim(adjustl(ci(j)))
         cnp=trim(cnp)//trim(adjustl(ck(i)))//trim(adjustl(ck(j)))
         ipl=0
         ipr=0
         do ip=1,nfsp
          if (izp(ip) > 0) then
           ipl=ipl+1
          else if (izp(ip) == 0) then
           ipr=nisp+ip
          end if
         end do
         if (nfsp-ipl <= 1) then
          iks=iks+1
          ckin=trim(ckin0)//trim(cnp)//'('//trim(ckin)
          if (ipr > 0) then
           write(ind,'(i4)') ipr
           ckin=trim(ckin)//trim(adjustl(ind))//','
          end if
          write(19,'(a)') ckin(:80)
          write(20,'(a)') ckin(81:)
          ckin=''
          cnp=''
         else
          ckin1=ckin
          cnp1=cnp
c          do k=1,iv
          do k=j+1,iv
           icrit=0
           do ip=1,nfsp
            icrit=icrit+izp(ip)*iyp(k,ip)
           end do
           if (icrit == 0) then
            itp=izp(:)+iyp(k,:)
            ckin=trim(ckin)//trim(adjustl(ci(k)))
            cnp=trim(cnp)//trim(adjustl(ck(k)))
            ipl=0
            ipr=0
            do ip=1,nfsp
             if (itp(ip) > 0) then
              ipl=ipl+1
             else if (itp(ip) == 0) then
              ipr=nisp+ip
             end if
            end do
            if (nfsp-ipl <= 1) then
             iks=iks+1
             ckin=trim(ckin0)//trim(cnp)//'('//trim(ckin)
             if (ipr > 0) then
              write(ind,'(i4)') ipr
              ckin=trim(ckin)//trim(adjustl(ind))//','
             end if
c             write(19,'(a)') ckin
          write(19,'(a)') ckin(:80)
          write(20,'(a)') ckin(81:)
             ckin=trim(ckin1)
             cnp=trim(cnp1)
            else

ckk>
             ckin2=ckin
             cnp2=cnp
c             do l=1,iv
             do l=k+1,iv
              icrit=0
              do ip=1,nfsp
               icrit=icrit+itp(ip)*iyp(l,ip)
              end do
              if (icrit == 0) then
               iup=itp(:)+iyp(l,:)
               ckin=trim(ckin)//trim(adjustl(ci(l)))
               cnp=trim(cnp)//trim(adjustl(ck(l)))
               ipl=0
               ipr=0
               do ip=1,nfsp
                if (iup(ip) > 0) then
                 ipl=ipl+1
                else if (iup(ip) == 0) then
                 ipr=nisp+ip
                end if
               end do
               if (nfsp-ipl <= 1) then
                iks=iks+1
                ckin=trim(ckin0)//trim(cnp)//'('//trim(ckin)
                if (ipr > 0) then
                 write(ind,'(i4)') ipr
                 ckin=trim(ckin)//trim(adjustl(ind))//','
                end if
                write(19,'(a)') ckin(:80)
                write(20,'(a)') ckin(81:)
                ckin=trim(ckin2)
                cnp=trim(cnp2)
               else
                ckin3=ckin
                cnp3=cnp
c                do m=1,iv
                do m=l+1,iv
                 icrit=0
                 do ip=1,nfsp
                  icrit=icrit+iup(ip)*iyp(m,ip)
                 end do
                 if (icrit == 0) then
                  isp=iup(:)+iyp(m,:)
                  ckin=trim(ckin)//trim(adjustl(ci(m)))
                  cnp=trim(cnp)//trim(adjustl(ck(m)))
                  ipl=0
                  ipr=0
                  do ip=1,nfsp
                   if (isp(ip) > 0) then
                    ipl=ipl+1
                   else if (isp(ip) == 0) then
                    ipr=nisp+ip
                   end if
                  end do
                  if (nfsp-ipl <= 1) then
                   iks=iks+1
                   ckin=trim(ckin0)//trim(cnp)//'('//trim(ckin)
                   if (ipr > 0) then
                    write(ind,'(i4)') ipr
                    ckin=trim(ckin)//trim(adjustl(ind))//','
                   end if
                   write(19,'(a)') ckin(:80)
                   write(20,'(a)') ckin(81:)
                   ckin=trim(ckin3)
                   cnp=trim(cnp3)
                  end if
                 end if
                end do
                ckin=trim(ckin2)
                cnp=trim(cnp2)
               end if
              end if
             end do
             ckin=trim(ckin1)
             cnp=trim(cnp1)
ckk<
            end if
           end if
          end do
          ckin=''
          cnp=''
         end if
        else
         ckin=''
         cnp=''
        end if
       end do
      end do

      close(19)
      close(20)

      open(unit=19,file='schcalls.txt',status='old',action='read')
      open(unit=18,file='schcalls2.txt',status='old',action='read')
      open(unit=20,file='kinschnl.f',status='replace',action='write')

      write(20,'(a)') '      subroutine kinschnl(ikin,imom,ecm,p,'
     &                                                //'x,ndim,dlips)'
      write(20,'(a)') ' '
      write(20,'(a)') '      use kinparams'
      write(20,'(a)') ' '
      write(20,'(a)') '      integer :: ikin,imom,ndim'
      write(20,'(a)') '      real(dp) :: x(ndim),dlips'
      if (iqprec == 1) then
       write(20,'(a)') '      real(qp) :: ecm,p(0:3,nexp)'
      else
       write(20,'(a)') '      real(dp) :: ecm,p(0:3,nexp)'
      end if
      write(20,'(a)') ' '

      iks=0

      do 
       read(19,'(a)',end=190) ckin(:80)
       read(18,'(a)',end=190) ckin(81:)
       iks=iks+1
       write(ind,'(i10)') iks
       if (iks == 1) then
        write(20,'(a)') '      if (ikin == '
     &                             //trim(adjustl(ind))//') then'
       else
        write(20,'(a)') '      else if (ikin == '
     &                             //trim(adjustl(ind))//') then'
       end if
       cls='      call '//trim(ckin)
       call wrt72(20,' '//trim(cls))
       write(20,'(a)') '     &                             '//
     &                                    'imom,ecm,p,x,ndim,dlips)'
      end do

 190  close(19)
      close(18)

      nkins=iks

      write(20,'(a)') '      end if'
      write(20,'(a)') ' '
      write(20,'(a)') '      end'
      
      close(20)

      call wrkinprms(next-nisp)

      end
